diff --git a/dlls/dinput/joystick.c b/dlls/dinput/joystick.c
index fcc968f0d71..94983ed837c 100644
--- a/dlls/dinput/joystick.c
+++ b/dlls/dinput/joystick.c
@@ -271,11 +271,23 @@ void dump_DIEFFECT(LPCDIEFFECT eff, REFGUID guid, DWORD dwFlags)
     }
 }
 
-BOOL device_disabled_registry(const char* name)
+static DWORD get_config_key_w( HKEY defkey, HKEY appkey, const WCHAR *name,
+                             WCHAR *buffer, DWORD size )
 {
-    static const char disabled_str[] = "disabled";
-    static const char joystick_key[] = "Joysticks";
-    char buffer[MAX_PATH];
+    if (appkey && !RegQueryValueExW( appkey, name, 0, NULL, (LPBYTE)buffer, &size ))
+        return 0;
+
+    if (defkey && !RegQueryValueExW( defkey, name, 0, NULL, (LPBYTE)buffer, &size ))
+        return 0;
+
+    return ERROR_FILE_NOT_FOUND;
+}
+
+BOOL device_disabled_registry(const WCHAR* name)
+{
+    static const WCHAR disabled_str[] = {'d','i','s','a','b','l','e','d',0};
+    static const WCHAR joystick_key[] = {'J','o','y','s','t','i','c','k','s',0};
+    WCHAR buffer[MAX_PATH];
     HKEY hkey, appkey, temp;
     BOOL do_disable = FALSE;
 
@@ -284,22 +296,22 @@ BOOL device_disabled_registry(const char* name)
     /* Joystick settings are in the 'joysticks' subkey */
     if (appkey)
     {
-        if (RegOpenKeyA(appkey, joystick_key, &temp)) temp = 0;
+        if (RegOpenKeyW(appkey, joystick_key, &temp)) temp = 0;
         RegCloseKey(appkey);
         appkey = temp;
     }
     if (hkey)
     {
-        if (RegOpenKeyA(hkey, joystick_key, &temp)) temp = 0;
+        if (RegOpenKeyW(hkey, joystick_key, &temp)) temp = 0;
         RegCloseKey(hkey);
         hkey = temp;
     }
 
     /* Look for the "controllername"="disabled" key */
-    if (!get_config_key(hkey, appkey, name, buffer, sizeof(buffer)))
-        if (!strcmp(disabled_str, buffer))
+    if (!get_config_key_w(hkey, appkey, name, buffer, sizeof(buffer)))
+        if (!strcmpW(disabled_str, buffer))
         {
-            TRACE("Disabling joystick '%s' based on registry key.\n", name);
+            TRACE("Disabling joystick '%s' based on registry key.\n", debugstr_w(name));
             do_disable = TRUE;
         }
 
diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index 0386bfa77e9..335cb67b673 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -175,11 +175,6 @@ static INT find_joystick_devices(void)
         /* Append driver name */
         strcat(joydev.name, JOYDEVDRIVER);
 
-        if (device_disabled_registry(joydev.name)) {
-            close(fd);
-            continue;
-        }
-
 #ifdef JSIOCGAXES
         if (ioctl(fd, JSIOCGAXES, &joydev.axis_count) < 0)
         {
diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index c34a73ec4e0..95fa5dacc26 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -264,14 +264,6 @@ static void find_joydevs(void)
         else
             joydev.name = joydev.device;
 
-        if (device_disabled_registry(joydev.name)) {
-            close(fd);
-            HeapFree(GetProcessHeap(), 0, joydev.name);
-            if (joydev.name != joydev.device)
-                HeapFree(GetProcessHeap(), 0, joydev.device);
-            continue;
-        }
-
         joydev.guid = DInput_Wine_Joystick_Base_GUID;
         joydev.guid.Data3 += have_joydevs;
 
diff --git a/dlls/dinput/joystick_private.h b/dlls/dinput/joystick_private.h
index 5327fa60566..39a837bd74c 100644
--- a/dlls/dinput/joystick_private.h
+++ b/dlls/dinput/joystick_private.h
@@ -57,7 +57,7 @@ HRESULT setup_dinput_options(JoystickGenericImpl *This, const int *default_axis_
 
 DWORD joystick_map_pov(const POINTL *p) DECLSPEC_HIDDEN;
 
-BOOL device_disabled_registry(const char* name) DECLSPEC_HIDDEN;
+extern BOOL device_disabled_registry(const WCHAR* name) DECLSPEC_HIDDEN;
 
 HRESULT WINAPI JoystickWGenericImpl_GetObjectInfo(LPDIRECTINPUTDEVICE8W iface,
         LPDIDEVICEOBJECTINSTANCEW pdidoi, DWORD dwObj, DWORD dwHow) DECLSPEC_HIDDEN;
-- 
2.28.0

>From e5e165554d036994de3759b97a358b98e4a89d1b Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Mon, 5 Oct 2020 12:44:47 +0200
Subject: [PATCH 11/39] dinput: Provide DIDEVICEINSTANCE on device init.

---
 dlls/dinput/device.c              | 18 ++++++++++++-
 dlls/dinput/device_private.h      |  4 ++-
 dlls/dinput/joystick.c            | 45 -------------------------------
 dlls/dinput/joystick_linux.c      | 35 +++++-------------------
 dlls/dinput/joystick_linuxinput.c | 33 +++++------------------
 dlls/dinput/joystick_osx.c        | 35 ++++++++++++++++++------
 dlls/dinput/joystick_private.h    |  5 ----
 dlls/dinput/keyboard.c            | 25 ++++-------------
 dlls/dinput/mouse.c               | 25 ++++-------------
 9 files changed, 69 insertions(+), 156 deletions(-)

diff --git a/dlls/dinput/device.c b/dlls/dinput/device.c
index 10b8580721a..129e8a2cb47 100644
--- a/dlls/dinput/device.c
+++ b/dlls/dinput/device.c
@@ -1366,6 +1366,21 @@ HRESULT WINAPI IDirectInputDevice2WImpl_SetProperty(
     return DI_OK;
 }
 
+HRESULT WINAPI IDirectInputDevice2WImpl_GetDeviceInfo(LPDIRECTINPUTDEVICE8W iface, LPDIDEVICEINSTANCEW didi)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8W(iface);
+
+    TRACE("(%p) %p\n", This, didi);
+
+    if (didi == NULL) return E_POINTER;
+    if ((didi->dwSize != sizeof(DIDEVICEINSTANCE_DX3W)) && (didi->dwSize != sizeof(DIDEVICEINSTANCEW)))
+        return DIERR_INVALIDPARAM;
+
+    memcpy((char *)didi + sizeof(didi->dwSize), (char *)&This->info + sizeof(didi->dwSize), didi->dwSize - sizeof(didi->dwSize));
+
+    return DI_OK;
+}
+
 HRESULT WINAPI IDirectInputDevice2WImpl_GetObjectInfo(
 	LPDIRECTINPUTDEVICE8W iface,
 	LPDIDEVICEOBJECTINSTANCEW pdidoi,
@@ -1628,7 +1643,7 @@ HRESULT WINAPI IDirectInputDevice8WImpl_GetImageInfo(LPDIRECTINPUTDEVICE8W iface
 }
 
 HRESULT direct_input_device_alloc(SIZE_T size, const IDirectInputDevice8WVtbl *vtbl, const GUID *guid,
-        IDirectInputImpl *dinput, void **out)
+        const DIDEVICEINSTANCEW *info, IDirectInputImpl *dinput, void **out)
 {
     IDirectInputDeviceImpl *This;
     if (!(This = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, size))) return DIERR_OUTOFMEMORY;
@@ -1636,6 +1651,7 @@ HRESULT direct_input_device_alloc(SIZE_T size, const IDirectInputDevice8WVtbl *v
     This->IDirectInputDevice8A_iface.lpVtbl = &direct_input_device_a_vtbl;
     This->ref = 1;
     This->guid = *guid;
+    This->info = *info;
     InitializeCriticalSection(&This->crit);
     This->dinput = dinput;
     IDirectInput_AddRef(&dinput->IDirectInput7A_iface);
diff --git a/dlls/dinput/device_private.h b/dlls/dinput/device_private.h
index fcab6dbedd0..95d1ea3e5b3 100644
--- a/dlls/dinput/device_private.h
+++ b/dlls/dinput/device_private.h
@@ -61,6 +61,7 @@ struct IDirectInputDeviceImpl
     IDirectInputDevice8A        IDirectInputDevice8A_iface;
     LONG                        ref;
     GUID                        guid;
+    DIDEVICEINSTANCEW           info;
     CRITICAL_SECTION            crit;
     IDirectInputImpl           *dinput;
     struct list                 entry;       /* entry into acquired device list */
@@ -89,7 +90,7 @@ struct IDirectInputDeviceImpl
 extern const IDirectInputDevice8AVtbl direct_input_device_a_vtbl DECLSPEC_HIDDEN;
 
 extern HRESULT direct_input_device_alloc(SIZE_T size, const IDirectInputDevice8WVtbl *vtbl, const GUID *guid,
-        IDirectInputImpl *dinput, void **out) DECLSPEC_HIDDEN;
+        const DIDEVICEINSTANCEW *info, IDirectInputImpl *dinput, void **out) DECLSPEC_HIDDEN;
 
 extern BOOL get_app_key(HKEY*, HKEY*) DECLSPEC_HIDDEN;
 extern DWORD get_config_key(HKEY, HKEY, const char*, char*, DWORD) DECLSPEC_HIDDEN;
@@ -152,6 +153,7 @@ extern HRESULT WINAPI IDirectInputDevice2WImpl_EnumObjects(
 	DWORD dwFlags)  DECLSPEC_HIDDEN;
 extern HRESULT WINAPI IDirectInputDevice2WImpl_GetProperty(LPDIRECTINPUTDEVICE8W iface, REFGUID rguid, LPDIPROPHEADER pdiph) DECLSPEC_HIDDEN;
 extern HRESULT WINAPI IDirectInputDevice2WImpl_SetProperty(LPDIRECTINPUTDEVICE8W iface, REFGUID rguid, LPCDIPROPHEADER pdiph) DECLSPEC_HIDDEN;
+extern HRESULT WINAPI IDirectInputDevice2WImpl_GetDeviceInfo(LPDIRECTINPUTDEVICE8W iface, LPDIDEVICEINSTANCEW didi) DECLSPEC_HIDDEN;
 extern HRESULT WINAPI IDirectInputDevice2WImpl_GetObjectInfo(LPDIRECTINPUTDEVICE8W iface, 
 							     LPDIDEVICEOBJECTINSTANCEW pdidoi,
 							     DWORD dwObj,
diff --git a/dlls/dinput/joystick.c b/dlls/dinput/joystick.c
index 94983ed837c..72e3e8d4fd6 100644
--- a/dlls/dinput/joystick.c
+++ b/dlls/dinput/joystick.c
@@ -645,51 +645,6 @@ HRESULT WINAPI JoystickWGenericImpl_GetProperty(LPDIRECTINPUTDEVICE8W iface, REF
     return DI_OK;
 }
 
-/******************************************************************************
-  *     GetDeviceInfo : get information about a device's identity
-  */
-HRESULT WINAPI JoystickWGenericImpl_GetDeviceInfo(
-    LPDIRECTINPUTDEVICE8W iface,
-    LPDIDEVICEINSTANCEW pdidi)
-{
-    JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
-    CHAR buffer[MAX_PATH];
-    DIPROPDWORD pd;
-    DWORD index = 0;
-
-    TRACE("(%p,%p)\n", iface, pdidi);
-
-    if ((pdidi->dwSize != sizeof(DIDEVICEINSTANCE_DX3W)) &&
-        (pdidi->dwSize != sizeof(DIDEVICEINSTANCEW))) {
-        WARN("invalid parameter: pdidi->dwSize = %d\n", pdidi->dwSize);
-        return DIERR_INVALIDPARAM;
-    }
-
-    /* Try to get joystick index */
-    pd.diph.dwSize = sizeof(pd);
-    pd.diph.dwHeaderSize = sizeof(pd.diph);
-    pd.diph.dwObj = 0;
-    pd.diph.dwHow = DIPH_DEVICE;
-    if (SUCCEEDED(IDirectInputDevice2_GetProperty(iface, DIPROP_JOYSTICKID, &pd.diph)))
-        index = pd.dwData;
-
-    /* Return joystick */
-    pdidi->guidInstance = This->guidInstance;
-    pdidi->guidProduct = This->guidProduct;
-    /* we only support traditional joysticks for now */
-    pdidi->dwDevType = This->devcaps.dwDevType;
-    snprintf(buffer, sizeof(buffer), "Joystick %d", index);
-    MultiByteToWideChar(CP_ACP, 0, buffer, -1, pdidi->tszInstanceName, MAX_PATH);
-    MultiByteToWideChar(CP_ACP, 0, This->name, -1, pdidi->tszProductName, MAX_PATH);
-    if (pdidi->dwSize > sizeof(DIDEVICEINSTANCE_DX3W)) {
-        pdidi->guidFFDriver = GUID_NULL;
-        pdidi->wUsagePage = 0;
-        pdidi->wUsage = 0;
-    }
-
-    return DI_OK;
-}
-
 HRESULT WINAPI JoystickWGenericImpl_Poll(LPDIRECTINPUTDEVICE8W iface)
 {
     JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index 335cb67b673..f043b4d7fed 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -419,25 +419,24 @@ static HRESULT joydev_enum_deviceA(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINS
 static HRESULT alloc_device(REFGUID rguid, IDirectInputImpl *dinput,
                             JoystickImpl **pdev, unsigned short index)
 {
+    DIDEVICEINSTANCEW didi = {sizeof(didi)};
     DWORD i;
     JoystickImpl* newDevice;
     HRESULT hr;
     LPDIDATAFORMAT df = NULL;
     int idx = 0;
-    DIDEVICEINSTANCEW ddi;
 
     TRACE("%s %p %p %hu\n", debugstr_guid(rguid), dinput, pdev, index);
 
+    fill_joystick_dideviceinstanceW(&didi, dinput->dwVersion, index);
+
     *pdev = NULL;
-    if (FAILED(hr = direct_input_device_alloc(sizeof(JoystickImpl), &JoystickWvt, rguid, dinput, (void **)&newDevice)))
+    if (FAILED(hr = direct_input_device_alloc(sizeof(JoystickImpl), &JoystickWvt, rguid, &didi, dinput, (void **)&newDevice)))
         return hr;
     newDevice->generic.base.crit.DebugInfo->Spare[0] = (DWORD_PTR)(__FILE__ ": JoystickImpl*->generic.base.crit");
 
     newDevice->joydev = &joystick_devices[index];
     newDevice->joyfd = -1;
-    newDevice->generic.guidInstance = DInput_Wine_Joystick_GUID;
-    newDevice->generic.guidInstance.Data3 = index;
-    newDevice->generic.guidProduct = DInput_Wine_Joystick_GUID;
     newDevice->generic.joy_polldev = joy_polldev;
     newDevice->generic.name        = newDevice->joydev->name;
     newDevice->generic.device_axis_count = newDevice->joydev->axis_count;
@@ -499,10 +498,7 @@ static HRESULT alloc_device(REFGUID rguid, IDirectInputImpl *dinput,
 
     newDevice->generic.devcaps.dwSize = sizeof(newDevice->generic.devcaps);
     newDevice->generic.devcaps.dwFlags = DIDC_ATTACHED;
-
-    ddi.dwSize = sizeof(ddi);
-    fill_joystick_dideviceinstanceW(&ddi, newDevice->generic.base.dinput->dwVersion, index);
-    newDevice->generic.devcaps.dwDevType = ddi.dwDevType;
+    newDevice->generic.devcaps.dwDevType = didi.dwDevType;
 
     newDevice->generic.devcaps.dwFFSamplePeriod = 0;
     newDevice->generic.devcaps.dwFFMinTimeResolution = 0;
@@ -675,25 +671,6 @@ static HRESULT WINAPI JoystickLinuxWImpl_GetProperty(LPDIRECTINPUTDEVICE8W iface
     return DI_OK;
 }
 
-/******************************************************************************
-  *     GetDeviceInfo : get information about a device's identity
-  */
-static HRESULT WINAPI JoystickLinuxWImpl_GetDeviceInfo(LPDIRECTINPUTDEVICE8W iface, LPDIDEVICEINSTANCEW ddi)
-{
-    JoystickImpl *This = impl_from_IDirectInputDevice8W(iface);
-
-    TRACE("(%p) %p\n", This, ddi);
-
-    if (ddi == NULL) return E_POINTER;
-    if ((ddi->dwSize != sizeof(DIDEVICEINSTANCE_DX3W)) &&
-        (ddi->dwSize != sizeof(DIDEVICEINSTANCEW)))
-        return DIERR_INVALIDPARAM;
-
-    fill_joystick_dideviceinstanceW( ddi, This->generic.base.dinput->dwVersion,
-                                     get_joystick_index(&This->generic.base.guid) );
-    return DI_OK;
-}
-
 /******************************************************************************
   *     Unacquire : frees the joystick
   */
@@ -811,7 +788,7 @@ static const IDirectInputDevice8WVtbl JoystickWvt =
     IDirectInputDevice2WImpl_SetEventNotification,
     IDirectInputDevice2WImpl_SetCooperativeLevel,
     JoystickWGenericImpl_GetObjectInfo,
-    JoystickLinuxWImpl_GetDeviceInfo,
+    IDirectInputDevice2WImpl_GetDeviceInfo,
     IDirectInputDevice2WImpl_RunControlPanel,
     IDirectInputDevice2WImpl_Initialize,
     IDirectInputDevice2WImpl_CreateEffect,
diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index 95fa5dacc26..4730ea9bc3f 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -413,13 +413,15 @@ static HRESULT joydev_enum_deviceA(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINS
 
 static JoystickImpl *alloc_device(REFGUID rguid, IDirectInputImpl *dinput, unsigned short index)
 {
+    DIDEVICEINSTANCEW didi = {sizeof(didi)};
     JoystickImpl* newDevice;
     LPDIDATAFORMAT df = NULL;
     int i, idx = 0;
     int default_axis_map[WINE_JOYSTICK_MAX_AXES + WINE_JOYSTICK_MAX_POVS*2];
-    DIDEVICEINSTANCEW ddi;
 
-    if (FAILED(direct_input_device_alloc(sizeof(JoystickImpl), &JoystickWvt, rguid, dinput, (void **)&newDevice)))
+    fill_joystick_dideviceinstanceW(&didi, dinput->dwVersion, index);
+
+    if (FAILED(direct_input_device_alloc(sizeof(JoystickImpl), &JoystickWvt, rguid, &didi, dinput, (void **)&newDevice)))
         return NULL;
     newDevice->generic.base.crit.DebugInfo->Spare[0] = (DWORD_PTR)(__FILE__ ": JoystickImpl*->base.crit");
 
@@ -535,10 +537,7 @@ static JoystickImpl *alloc_device(REFGUID rguid, IDirectInputImpl *dinput, unsig
     /* Fill the caps */
     newDevice->generic.devcaps.dwSize = sizeof(newDevice->generic.devcaps);
     newDevice->generic.devcaps.dwFlags = DIDC_ATTACHED;
-
-    ddi.dwSize = sizeof(ddi);
-    fill_joystick_dideviceinstanceW(&ddi, newDevice->generic.base.dinput->dwVersion, index);
-    newDevice->generic.devcaps.dwDevType = ddi.dwDevType;
+    newDevice->generic.devcaps.dwDevType = didi.dwDevType;
 
     if (newDevice->joydev->has_ff)
         newDevice->generic.devcaps.dwFlags |= DIDC_FORCEFEEDBACK;
@@ -1210,26 +1209,6 @@ static HRESULT WINAPI JoystickWImpl_EnumCreatedEffectObjects(LPDIRECTINPUTDEVICE
     return DI_OK;
 }
 
-/******************************************************************************
-  *     GetDeviceInfo : get information about a device's identity
-  */
-static HRESULT WINAPI JoystickWImpl_GetDeviceInfo(LPDIRECTINPUTDEVICE8W iface,
-                                                  LPDIDEVICEINSTANCEW pdidi)
-{
-    JoystickImpl *This = impl_from_IDirectInputDevice8W(iface);
-
-    TRACE("(%p) %p\n", This, pdidi);
-
-    if (pdidi == NULL) return E_POINTER;
-    if ((pdidi->dwSize != sizeof(DIDEVICEINSTANCE_DX3W)) &&
-        (pdidi->dwSize != sizeof(DIDEVICEINSTANCEW)))
-        return DIERR_INVALIDPARAM;
-
-    fill_joystick_dideviceinstanceW(pdidi, This->generic.base.dinput->dwVersion,
-                                    get_joystick_index(&This->generic.base.guid));
-    return DI_OK;
-}
-
 static const IDirectInputDevice8WVtbl JoystickWvt =
 {
     IDirectInputDevice2WImpl_QueryInterface,
@@ -1247,7 +1226,7 @@ static const IDirectInputDevice8WVtbl JoystickWvt =
     IDirectInputDevice2WImpl_SetEventNotification,
     IDirectInputDevice2WImpl_SetCooperativeLevel,
     JoystickWGenericImpl_GetObjectInfo,
-    JoystickWImpl_GetDeviceInfo,
+    IDirectInputDevice2WImpl_GetDeviceInfo,
     IDirectInputDevice2WImpl_RunControlPanel,
     IDirectInputDevice2WImpl_Initialize,
     JoystickWImpl_CreateEffect,
diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index def374d047d..d13346f50e2 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -1019,9 +1019,30 @@ static BOOL osx_axis_has_ff(FFCAPABILITIES *ffcaps, UInt8 axis)
     return FALSE;
 }
 
+static void fill_joystick_dideviceinstanceW(LPDIDEVICEINSTANCEW didi, IOHIDDeviceRef device, DWORD version, int index, const char *name)
+{
+    char buffer[MAX_PATH];
+
+    didi->guidInstance = DInput_Wine_OsX_Joystick_GUID;
+    didi->guidInstance.Data3 = index;
+    didi->guidProduct = DInput_PIDVID_Product_GUID;
+    didi->guidProduct.Data1 = make_vid_pid(device);
+    if (version >= 0x0800) didi->dwDevType = DI8DEVTYPE_JOYSTICK | (DI8DEVTYPEJOYSTICK_STANDARD << 8);
+    else didi->dwDevType = DIDEVTYPE_JOYSTICK | (DIDEVTYPEJOYSTICK_TRADITIONAL << 8);
+
+    snprintf(buffer, sizeof(buffer), "Joystick %d", index);
+    MultiByteToWideChar(CP_ACP, 0, buffer, -1, didi->tszInstanceName, MAX_PATH);
+    MultiByteToWideChar(CP_ACP, 0, name, -1, didi->tszProductName, MAX_PATH);
+
+    didi->guidFFDriver = GUID_NULL;
+    didi->wUsagePage = 0;
+    didi->wUsage = 0;
+}
+
 static HRESULT alloc_device(REFGUID rguid, IDirectInputImpl *dinput,
                             JoystickImpl **pdev, unsigned short index)
 {
+    DIDEVICEINSTANCEW didi = {sizeof(didi)};
     DWORD i;
     IOHIDDeviceRef device;
     JoystickImpl* newDevice;
@@ -1035,18 +1056,16 @@ static HRESULT alloc_device(REFGUID rguid, IDirectInputImpl *dinput,
 
     TRACE("%s %p %p %hu\n", debugstr_guid(rguid), dinput, pdev, index);
 
-    if (FAILED(hr = direct_input_device_alloc(sizeof(JoystickImpl), &JoystickWvt, rguid, dinput, (void **)&newDevice)))
+    device = get_device_ref(index);
+
+    fill_joystick_dideviceinstanceW(&didi, device, dinput->dwVersion, index, name);
+
+    if (FAILED(hr = direct_input_device_alloc(sizeof(JoystickImpl), &JoystickWvt, rguid, &didi, dinput, (void **)&newDevice)))
         return hr;
     newDevice->generic.base.crit.DebugInfo->Spare[0] = (DWORD_PTR)(__FILE__ ": JoystickImpl*->generic.base.crit");
 
     newDevice->id = index;
 
-    device = get_device_ref(index);
-
-    newDevice->generic.guidInstance = DInput_Wine_OsX_Joystick_GUID;
-    newDevice->generic.guidInstance.Data3 = index;
-    newDevice->generic.guidProduct = DInput_PIDVID_Product_GUID;
-    newDevice->generic.guidProduct.Data1 = make_vid_pid(device);
     newDevice->generic.joy_polldev = poll_osx_device_state;
 
     /* get the device name */
@@ -1440,7 +1459,7 @@ static const IDirectInputDevice8WVtbl JoystickWvt =
     IDirectInputDevice2WImpl_SetEventNotification,
     IDirectInputDevice2WImpl_SetCooperativeLevel,
     JoystickWGenericImpl_GetObjectInfo,
-    JoystickWGenericImpl_GetDeviceInfo,
+    IDirectInputDevice2WImpl_GetDeviceInfo,
     IDirectInputDevice2WImpl_RunControlPanel,
     IDirectInputDevice2WImpl_Initialize,
     JoystickWImpl_CreateEffect,
diff --git a/dlls/dinput/joystick_private.h b/dlls/dinput/joystick_private.h
index 39a837bd74c..b82632c39d2 100644
--- a/dlls/dinput/joystick_private.h
+++ b/dlls/dinput/joystick_private.h
@@ -42,8 +42,6 @@ typedef struct JoystickGenericImpl
     ObjProps    props[MAX_PROPS];
     DIDEVCAPS   devcaps;
     DIJOYSTATE2 js;     /* wine data */
-    GUID        guidProduct;
-    GUID        guidInstance;
     char        *name;
     int         device_axis_count;      /* Total number of axes in the device */
     int        *axis_map;               /* User axes remapping */
@@ -70,9 +68,6 @@ void _dump_DIDEVCAPS(const DIDEVCAPS *lpDIDevCaps) DECLSPEC_HIDDEN;
 
 HRESULT WINAPI JoystickWGenericImpl_SetProperty(LPDIRECTINPUTDEVICE8W iface, REFGUID rguid, LPCDIPROPHEADER ph) DECLSPEC_HIDDEN;
 
-HRESULT WINAPI JoystickWGenericImpl_GetDeviceInfo( LPDIRECTINPUTDEVICE8W iface,
-    LPDIDEVICEINSTANCEW pdidi) DECLSPEC_HIDDEN;
-
 HRESULT WINAPI JoystickWGenericImpl_Poll(LPDIRECTINPUTDEVICE8W iface) DECLSPEC_HIDDEN;
 
 HRESULT WINAPI JoystickWGenericImpl_GetDeviceState(LPDIRECTINPUTDEVICE8W iface, DWORD len, LPVOID ptr) DECLSPEC_HIDDEN;
diff --git a/dlls/dinput/keyboard.c b/dlls/dinput/keyboard.c
index 57e057cfbe7..11d41a2ce4c 100644
--- a/dlls/dinput/keyboard.c
+++ b/dlls/dinput/keyboard.c
@@ -196,11 +196,14 @@ static HRESULT keyboarddev_enum_deviceW(DWORD dwDevType, DWORD dwFlags, LPDIDEVI
 
 static SysKeyboardImpl *alloc_device(REFGUID rguid, IDirectInputImpl *dinput)
 {
+    DIDEVICEINSTANCEW didi = {sizeof(didi)};
     SysKeyboardImpl* newDevice;
     LPDIDATAFORMAT df = NULL;
     int i, idx = 0;
 
-    if (FAILED(direct_input_device_alloc(sizeof(SysKeyboardImpl), &SysKeyboardWvt, rguid, dinput, (void **)&newDevice)))
+    fill_keyboard_dideviceinstanceW(&didi, dinput->dwVersion, get_keyboard_subtype());
+
+    if (FAILED(direct_input_device_alloc(sizeof(SysKeyboardImpl), &SysKeyboardWvt, rguid, &didi, dinput, (void **)&newDevice)))
         return NULL;
     newDevice->base.crit.DebugInfo->Spare[0] = (DWORD_PTR)(__FILE__ ": SysKeyboardImpl*->base.crit");
 
@@ -381,24 +384,6 @@ static HRESULT WINAPI SysKeyboardWImpl_GetObjectInfo(LPDIRECTINPUTDEVICE8W iface
     return res;
 }
 
-/******************************************************************************
-  *     GetDeviceInfo : get information about a device's identity
-  */
-static HRESULT WINAPI SysKeyboardWImpl_GetDeviceInfo(LPDIRECTINPUTDEVICE8W iface, LPDIDEVICEINSTANCEW pdidi)
-{
-    SysKeyboardImpl *This = impl_from_IDirectInputDevice8W(iface);
-    TRACE("(this=%p,%p)\n", This, pdidi);
-
-    if (pdidi->dwSize != sizeof(DIDEVICEINSTANCEW)) {
-        WARN(" dinput3 not supported yet...\n");
-	return DI_OK;
-    }
-
-    fill_keyboard_dideviceinstanceW(pdidi, This->base.dinput->dwVersion, This->subtype);
-    
-    return DI_OK;
-}
-
 /******************************************************************************
  *      GetProperty : Retrieves information about the input device.
  */
@@ -495,7 +480,7 @@ static const IDirectInputDevice8WVtbl SysKeyboardWvt =
     IDirectInputDevice2WImpl_SetEventNotification,
     IDirectInputDevice2WImpl_SetCooperativeLevel,
     SysKeyboardWImpl_GetObjectInfo,
-    SysKeyboardWImpl_GetDeviceInfo,
+    IDirectInputDevice2WImpl_GetDeviceInfo,
     IDirectInputDevice2WImpl_RunControlPanel,
     IDirectInputDevice2WImpl_Initialize,
     IDirectInputDevice2WImpl_CreateEffect,
diff --git a/dlls/dinput/mouse.c b/dlls/dinput/mouse.c
index 608f8392925..0e3a8976033 100644
--- a/dlls/dinput/mouse.c
+++ b/dlls/dinput/mouse.c
@@ -140,13 +140,16 @@ static HRESULT mousedev_enum_deviceW(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEI
 
 static SysMouseImpl *alloc_device(REFGUID rguid, IDirectInputImpl *dinput)
 {
+    DIDEVICEINSTANCEW didi = {sizeof(didi)};
     SysMouseImpl* newDevice;
     LPDIDATAFORMAT df = NULL;
     unsigned i;
     char buffer[20];
     HKEY hkey, appkey;
 
-    if (FAILED(direct_input_device_alloc(sizeof(SysMouseImpl), &SysMouseWvt, rguid, dinput, (void **)&newDevice)))
+    fill_mouse_dideviceinstanceW(&didi, dinput->dwVersion);
+
+    if (FAILED(direct_input_device_alloc(sizeof(SysMouseImpl), &SysMouseWvt, rguid, &didi, dinput, (void **)&newDevice)))
         return NULL;
     newDevice->base.crit.DebugInfo->Spare[0] = (DWORD_PTR)(__FILE__ ": SysMouseImpl*->base.crit");
 
@@ -692,24 +695,6 @@ static HRESULT WINAPI SysMouseWImpl_GetObjectInfo(LPDIRECTINPUTDEVICE8W iface,
     return res;
 }
 
-/******************************************************************************
-  *     GetDeviceInfo : get information about a device's identity
-  */
-static HRESULT WINAPI SysMouseWImpl_GetDeviceInfo(LPDIRECTINPUTDEVICE8W iface, LPDIDEVICEINSTANCEW pdidi)
-{
-    SysMouseImpl *This = impl_from_IDirectInputDevice8W(iface);
-    TRACE("(this=%p,%p)\n", This, pdidi);
-
-    if (pdidi->dwSize != sizeof(DIDEVICEINSTANCEW)) {
-        WARN(" dinput3 not supported yet...\n");
-	return DI_OK;
-    }
-
-    fill_mouse_dideviceinstanceW(pdidi, This->base.dinput->dwVersion);
-    
-    return DI_OK;
-}
-
 static HRESULT WINAPI SysMouseWImpl_BuildActionMap(LPDIRECTINPUTDEVICE8W iface,
                                                    LPDIACTIONFORMATW lpdiaf,
                                                    LPCWSTR lpszUserName,
@@ -748,7 +733,7 @@ static const IDirectInputDevice8WVtbl SysMouseWvt =
     IDirectInputDevice2WImpl_SetEventNotification,
     IDirectInputDevice2WImpl_SetCooperativeLevel,
     SysMouseWImpl_GetObjectInfo,
-    SysMouseWImpl_GetDeviceInfo,
+    IDirectInputDevice2WImpl_GetDeviceInfo,
     IDirectInputDevice2WImpl_RunControlPanel,
     IDirectInputDevice2WImpl_Initialize,
     IDirectInputDevice2WImpl_CreateEffect,
-- 
2.28.0

>From a42f6d7ad35f1e4b05c395c0af4bcf1e2356ebe1 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Mon, 5 Oct 2020 12:44:47 +0200
Subject: [PATCH 12/39] dinput: Provide VID/PID and index on device init.

---
 dlls/dinput/device.c              |  7 +++++--
 dlls/dinput/device_private.h      |  7 +++++--
 dlls/dinput/joystick_linux.c      | 26 +++++++++++---------------
 dlls/dinput/joystick_linuxinput.c | 25 +++++++++++--------------
 dlls/dinput/joystick_osx.c        | 18 +++++++++---------
 dlls/dinput/keyboard.c            |  2 +-
 dlls/dinput/mouse.c               |  2 +-
 7 files changed, 43 insertions(+), 44 deletions(-)

diff --git a/dlls/dinput/device.c b/dlls/dinput/device.c
index 129e8a2cb47..a2c1b638cfc 100644
--- a/dlls/dinput/device.c
+++ b/dlls/dinput/device.c
@@ -1642,8 +1642,8 @@ HRESULT WINAPI IDirectInputDevice8WImpl_GetImageInfo(LPDIRECTINPUTDEVICE8W iface
     return DI_OK;
 }
 
-HRESULT direct_input_device_alloc(SIZE_T size, const IDirectInputDevice8WVtbl *vtbl, const GUID *guid,
-        const DIDEVICEINSTANCEW *info, IDirectInputImpl *dinput, void **out)
+HRESULT direct_input_device_alloc(SIZE_T size, const IDirectInputDevice8WVtbl *vtbl, const GUID *guid, WORD vid,
+        WORD pid, WORD iid, const DIDEVICEINSTANCEW *info, IDirectInputImpl *dinput, void **out)
 {
     IDirectInputDeviceImpl *This;
     if (!(This = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, size))) return DIERR_OUTOFMEMORY;
@@ -1651,6 +1651,9 @@ HRESULT direct_input_device_alloc(SIZE_T size, const IDirectInputDevice8WVtbl *v
     This->IDirectInputDevice8A_iface.lpVtbl = &direct_input_device_a_vtbl;
     This->ref = 1;
     This->guid = *guid;
+    This->vendor_id = vid;
+    This->product_id = pid;
+    This->instance_id = iid;
     This->info = *info;
     InitializeCriticalSection(&This->crit);
     This->dinput = dinput;
diff --git a/dlls/dinput/device_private.h b/dlls/dinput/device_private.h
index 95d1ea3e5b3..52a7b3c3dc7 100644
--- a/dlls/dinput/device_private.h
+++ b/dlls/dinput/device_private.h
@@ -61,6 +61,9 @@ struct IDirectInputDeviceImpl
     IDirectInputDevice8A        IDirectInputDevice8A_iface;
     LONG                        ref;
     GUID                        guid;
+    WORD                        vendor_id;
+    WORD                        product_id;
+    WORD                        instance_id;
     DIDEVICEINSTANCEW           info;
     CRITICAL_SECTION            crit;
     IDirectInputImpl           *dinput;
@@ -89,8 +92,8 @@ struct IDirectInputDeviceImpl
 
 extern const IDirectInputDevice8AVtbl direct_input_device_a_vtbl DECLSPEC_HIDDEN;
 
-extern HRESULT direct_input_device_alloc(SIZE_T size, const IDirectInputDevice8WVtbl *vtbl, const GUID *guid,
-        const DIDEVICEINSTANCEW *info, IDirectInputImpl *dinput, void **out) DECLSPEC_HIDDEN;
+extern HRESULT direct_input_device_alloc(SIZE_T size, const IDirectInputDevice8WVtbl *vtbl, const GUID *guid, WORD vid,
+        WORD pid, WORD iid, const DIDEVICEINSTANCEW *info, IDirectInputImpl *dinput, void **out) DECLSPEC_HIDDEN;
 
 extern BOOL get_app_key(HKEY*, HKEY*) DECLSPEC_HIDDEN;
 extern DWORD get_config_key(HKEY, HKEY, const char*, char*, DWORD) DECLSPEC_HIDDEN;
